/*
* -myapp commandline handler; starts up My App.
*/

 Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

 const nsIAppShellService    = Components.interfaces.nsIAppShellService;
 const nsISupports           = Components.interfaces.nsISupports;
 const nsICategoryManager    = Components.interfaces.nsICategoryManager;
 const nsIComponentRegistrar = Components.interfaces.nsIComponentRegistrar;
 const nsICommandLine        = Components.interfaces.nsICommandLine;
 const nsICommandLineHandler = Components.interfaces.nsICommandLineHandler;
 const nsIFactory            = Components.interfaces.nsIFactory;
 const nsIModule             = Components.interfaces.nsIModule;
 const nsIWindowWatcher      = Components.interfaces.nsIWindowWatcher;

 var consoleService = Components
  .classes['@mozilla.org/consoleservice;1']
  .getService( Components.interfaces.nsIConsoleService );

 function recordMessage( message ) {
  consoleService.logStringMessage("esc: " + message  + "\n");
 }

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

/*
* Classes
*/

function escCLH() {}
 
  escCLH.prototype = {


   contractID:  "@redhat.com/esc-clh;1",
   classID:  Components.ID("{36c65861-52a8-4ce9-aa3b-235b88216ed4}"),
  // const clh_category = "c-esc";


   /* nsISupports */

   QueryInterface : XPCOMUtils.generateQI([nsICommandLineHandler]),


   /* nsICommandLineHandler */

   handle : function clh_handle(cmdLine) {
       var args = new Object();
       args.urlopt = false;

       recordMessage("handle command line");

       try {

           var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
           var win = wm.getMostRecentWindow(null);

           var showUsage = cmdLine.handleFlag("usage",false);

           recordMessage("ShowUsage flag: " + showUsage);
           if(showUsage) {
               cmdLine.preventDefault = true;
           }

           if(win)
           {
               recordMessage("Subsequent command invocation. Launch appropriate  page.");
               if(showUsage) 
               {
                   recordMessage("About to show usage.");
                   win.ShowUsage();
                   return;
               }
               var locName = win.location.toString();

               recordMessage("Base window . " + locName);

               win.SelectESCPageCMDLine();

               recordMessage("Done command line handling...");
               return;
           }
           
           var chromeURI = "chrome://esc/content/hiddenWindow.xul";

           recordMessage(chromeURI);

           var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                         .getService(nsIWindowWatcher);
           win = wwatch.openWindow(null, chromeURI, "_blank",
                     "chrome,dialog,height=-1,width=-1,popup=yes", cmdLine);


       }
       catch(e) {}

   },

   helpInfo : "  -myapp  Open the My App.\n",

 };

 /* Module initialisation */

var NSGetFactory = XPCOMUtils.generateNSGetFactory([escCLH]);
